########################################################################
#
# File Name:            Fetch.Resource.py
#
# Documentation:        http://docs.4suite.org/4SS/Lib/CommandLine.py.html
#
"""
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""

__doc__ = """Fetch information about any resource in the system"""

import sys
from Ft.Server import FtServerBaseException
from Ft.Server.Client.Commands import CommandUtil


def Run(options, args):

    try:
        repo = CommandUtil.GetRepository(options,'4ss.fetch.resource')
        try:
            ri = repo.fetchResource(args['uri'],traverseAliases = 0)
            ri.pprint()
        finally:
            repo.txRollback()
    except FtServerBaseException, e:
        sys.stderr.write(str(e))
        return


def Register():

    from Ft.Lib.CommandLine import Options, Command, Arguments

    cmd = Command.Command('resource',
                          'Display info (metadata) about a resource in the repository',
                          'fourthought.com/index.html',
                          __doc__,
                          function = Run,
                          arguments = [Arguments.RequiredArgument('uri',
                                                                  'The URI of the resource for which to fetch metadata',
                                                                  str),
                                       ],

                          fileName = __file__,
                          )
    return cmd

