########################################################################
#
# File Name:            List.DocDefs.py
#
# Documentation:        http://docs.4suite.org/4SS/Lib/CommandLine.py.html
#
"""
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""

__doc__ = """Display a list of all document definitions in a meta xml server."""

import sys
from Ft.Server.Client import FtServerClientException
from Ft.Server.Client.Commands import CommandUtil

def Run(options,args):
    try:
        repo = CommandUtil.GetRepository(options, '4ss.list.docdefs')
        try:
            dds = repo.getAllDocumentDefinitionPaths()
        finally:
            try:
                repo.txRollback()
            except:
                pass
    except FtServerClientException, e:
        sys.stderr.write(str(e))
        return


    sys.stderr.write("Document Definitions in the system")
    sys.stderr.write("-"*20+"\n")

    for d in dds:
        print d


def Register():

    from Ft.Lib.CommandLine import Options, Command, Arguments
    cmd = Command.Command('docdefs',
                          'List the document definitions available in the system.',
                          '',
                          __doc__,
                          function=Run,
                          arguments=[
                                    ],
                          fileName=__file__,
                          )
    return cmd

