# common option for most commands

from Ft.Lib.CommandLine import Options, CommandLineApp

from Ft.Server.Common import ClAuthenticate
from Ft.Server import FtServerBaseException

g_options = [Options.Option('u',
                            'username=',
                            'connect using the given user name'),
             Options.Option('p',
                            'password=',
                            'connect using the given password'),
             Options.Option('I',
                            'core-id=name',
                            'use alternative core section (default Core)'),
             Options.Option('C',
                            'config-file=filename',
                            'use alterntive configuration file in the configuration directory'),
             ]






__doc__ = """Command line application to Run 4SS Management tools.  You will need manager ACL permissions to perform tasks using this tool."""


import Init
import Log
import Start
import Stop
import Restart
import Recompile
##import Status
##import Console
import Backup
##import Restore

##import Set
##import Add
##import Remove
##import Compile

g_commands = [Init,
              Log,
              Start,
              Stop,
              Restart,
              Recompile,
              Backup,
##              Status,
##              Console,
##              Restore,
##              Set,
##              Add,
##              Remove,
##              Compile,
              ]



class ManagerCommandLineApp(CommandLineApp.CommandLineApp):

    def __init__(self):
        CommandLineApp.CommandLineApp.__init__(self,
                                               '4ss_manager',
                                               'Application to Run 4SS Management tools',
                                               __doc__,
                                               map(lambda x:x.Register(),g_commands),
                                               options = g_options,
                                               #authenticationFunction = ClAuthenticate.UserAuthenticate,
                                               fileName = __file__,
                                               )


    def run(*args, **kw):
        try:
            return apply(CommandLineApp.CommandLineApp.run,args,kw)
        except FtServerBaseException,e:
            print e
