from Ft.Server import FTSERVER_NAMESPACE
from Ft.Server.Server import FtServerServerException, Error
from Ft.Server.Common import ResourceTypes, Schema
import XmlDocumentImp

class AliasImp(XmlDocumentImp.XmlDocumentImp):
    resourceType = ResourceTypes.ResourceType.ALIAS

    def getReference(self):
        """
        Traverses the alias and returns its reference (1 step)
        """
        self._verifyTx()

        stmts = self._driver.getSystemModel().complete(self._path.absolutePath,Schema.ALIAS_REFERENCE,None)
        if not len(stmts):
            raise FtServerServerException(Error.BROKEN_ALIAS,
                                          path = self._path.displayPath)

        if not self.hasResource(stmts[0].object):
            raise FtServerServerException(Error.BROKEN_ALIAS,
                                          path = self._path.displayPath)

        return self.fetchResource(stmts[0].object,0)


    def traverse(self):
        """
        Traverses the alias and returns its reference (n steps)
        """
        self._verifyTx()
        next = self.getReference()
        if next.isResourceType(ResourceTypes.ResourceType.ALIAS):
            return next.traverse()
        return next


def NewAliasXml(driver,reference,path,acl,owner,docDef):
    content = """<ftss:Alias xmlns:ftss="%s" reference='%s'/>"""% (FTSERVER_NAMESPACE,str(reference))
    return (XmlDocumentImp.NewXmlDocumentXml(driver,
                                             path,
                                             acl,
                                             owner,
                                             'text/xml',
                                             content,
                                             docDef,
                                             ResourceTypes.ResourceType.ALIAS)
            ,content)

