#import os, cPickle, sys
import XmlDocumentImp
from Ft.Xml.Xslt import StylesheetReader

from Ft.Server.Common import ResourceTypes, SchematronStylesheet

class SchematronDocumentImp(XmlDocumentImp.XmlDocumentImp):
    """
    Provides implementation specific to a schematron document resource
    """
    resourceType = ResourceTypes.ResourceType.SCHEMATRON_DOCUMENT

    def asSchematron(self):
        self._verifyTx()
        r = StylesheetReader.StylesheetReader()
        return r.fromInstant(self._driver.fetchResourceCache(self._path),
                             self._path.absolutePath)


    def setContent(self, src):
        XmlDocumentImp.XmlDocumentImp.setContent(self,src)

        sch = SchematronStylesheet.ParseSchematron(src,
                                                   self._path.absolutePath,
                                                   self._driver).root
        self._driver.setResourceCache(self._path,
                                      sch
                                      )




