import XmlDocumentImp
from Ft.Server.Common import ResourceTypes

from Ft.Server import FTSERVER_NAMESPACE


class ServerImp(XmlDocumentImp.XmlDocumentImp):
    """
    A system server
    """
    resourceType = ResourceTypes.ResourceType.SERVER



    def setRunning(self):
        """
        Change the state of this server to running
        """
        self._verifyTx()

        xu = UPDATE_STATE%(FTSERVER_NAMESPACE,'1')
        self._driver.xupdateContent(self._path,xu)

    def setStopped(self):
        """
        Change the state of this server stopped
        """
        self._verifyTx()

        xu = REMOVE_STATE%(FTSERVER_NAMESPACE)
        self._driver.xupdateContent(self._path,xu)


        
UPDATE_STATE="""<?xml version="1.0"?>
<xupdate:modifications
  version="1.0"
  xmlns:xupdate="http://www.xmldb.org/xupdate"
  xmlns:ftss="%s"
>
<xupdate:remove select="/ftss:Server/ftss:Status"/>
<xupdate:append select="/ftss:Server" child='last()'><ftss:Status running = '%s'/></xupdate:append>
</xupdate:modifications>
"""

REMOVE_STATE="""<?xml version="1.0"?>
<xupdate:modifications
  version="1.0"
  xmlns:xupdate="http://www.xmldb.org/xupdate"
  xmlns:ftss="%s"
>
<xupdate:remove select="/ftss:Server/ftss:Status"/>
</xupdate:modifications>
"""
