<?xml version="1.0"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY nbsp "&#160;">
  <!ENTITY bbschema "http://uche.ogbuji.net/example/buyerbase/schema#">
  <!ENTITY bb "http://uche.ogbuji.net/example/buyerbase">
  <!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
  <!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
  <!ENTITY f	"http://xmlns.4suite.org/ext">
  <!ENTITY fres "http://xmlns.4suite.org/reserved">
  <!ENTITY dc "http://purl.org/dc/elements/1.1#">
]>
<xsl:stylesheet
  version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:fcore="http://xmlns.4suite.org/4ss/score" 
  xmlns:frdf="http://xmlns.4suite.org/4ss/rdf" 
  xmlns:fhttp="http://xmlns.4suite.org/4ss/http"
  xmlns:exslt="http://exslt.org/common"
  xmlns:exslt-set="http://exslt.org/sets"
  xmlns:exslt-math="http://exslt.org/math"
  xmlns:exslt-functions="http://exslt.org/functions"
  xmlns:exslt-date-time="http://exslt.org/dates-and-times"
  xmlns:dc="&dc;" 
  xmlns:fres="&fres;"
  xmlns:bb="&bb;" 
  xmlns:rdf="&rdf;" 
  xmlns:f="&f;" 
  xmlns:xlink='http://www.w3.org/1999/xlink'
  extension-element-prefixes="f frdf fhttp fcore exslt exslt-set exslt-math exslt-functions exslt-date-time">

  <!--
File:  cl-container.xslt

Description:

    Used by the 4ss command line when fetch container is called

WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 2000-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information

  -->

  <xsl:output method='text'/>

  <xsl:param name='fres:absolute-path'/>
  <xsl:param name='fres:base-path'/>
  
  <xsl:template match='/'>
    <xsl:text>Listing of </xsl:text><xsl:value-of select='$fres:absolute-path'/><xsl:text>&#10;</xsl:text>
    <xsl:apply-templates select='fres:Container/fres:Children/fres:ChildReference'/>
    <xsl:text>total: </xsl:text><xsl:value-of select='count(fres:Container/fres:Children/fres:ChildReference)'/>
  </xsl:template>

  <xsl:template match='fres:ChildReference'>
    <xsl:apply-templates select='document(f:resolve-url($fres:base-path,@xlink:href))/fres:MetaData'>
      <xsl:sort select='@path'/>
    </xsl:apply-templates>
  </xsl:template>

  <xsl:template match='fres:MetaData'>
    <xsl:param name='max-size' select='6'/>
    <xsl:param name='max-imt' select='10'/>
    <xsl:param name='max-time' select='15'/>

    <xsl:variable name='display' select='@path'/>
    <xsl:variable name='actual-display'>
      <xsl:choose>
        <xsl:when test='starts-with($display,"/")'>
          <xsl:value-of select='substring-after($display,"/")'/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='$display'/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:value-of select='fres:Imt'/>
    <xsl:call-template name='add-space'>
      <xsl:with-param name = 'num' select='$max-imt - string-length(fres:Imt)'/>
    </xsl:call-template>

    <xsl:variable name='size' select='format-number(fres:Size div 1000.0, "#,###.0k")'/>
    <xsl:call-template name='add-space'>
      <xsl:with-param name = 'num' select='$max-size - string-length($size)'/>
    </xsl:call-template>
    <xsl:value-of select='$size'/>
    <xsl:text> </xsl:text>
    <xsl:variable name='now' select='fres:LastModifiedDate'/>
    <xsl:variable name='time' select = 'concat(exslt-date-time:month-abbreviation($now)," ",exslt-date-time:day-in-month($now)," ",exslt-date-time:hour-in-day($now),":",exslt-date-time:minute-in-hour($now))'/>
    <xsl:value-of select='$time'/>
    <xsl:call-template name='add-space'>
      <xsl:with-param name = 'num' select='$max-time - string-length($time)'/>
    </xsl:call-template>
    <xsl:value-of select='$actual-display'/>

    <xsl:apply-templates select='frdf:complete(concat($fres:absolute-path,"/",@path),"http://schemas.4suite.org/4ss#alias.reference",frdf:any())[1]' mode='alias-ref'/>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <xsl:template match='Statement' mode='alias-ref'>
    <xsl:text>--&gt; </xsl:text><xsl:value-of select='Object'/>
  </xsl:template>

  <xsl:template name='add-space'>
    <xsl:param name='num'/>
    <xsl:if test='$num > 0'>
      <xsl:text> </xsl:text>
      <xsl:call-template name='add-space'>
        <xsl:with-param name='num' select='$num - 1'/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
