<?xml version="1.0"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY nbsp "&#160;">
  <!ENTITY bbschema "http://uche.ogbuji.net/example/buyerbase/schema#">
  <!ENTITY bb "http://uche.ogbuji.net/example/buyerbase">
  <!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
  <!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
  <!ENTITY f  "http://xmlns.4suite.org/ext">
  <!ENTITY fres "http://xmlns.4suite.org/reserved">
  <!ENTITY dc "http://purl.org/dc/elements/1.1#">
]>
<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:fcore="http://xmlns.4suite.org/4ss/score"
  xmlns:frdf="http://xmlns.4suite.org/4ss/rdf"
  xmlns:fhttp="http://xmlns.4suite.org/4ss/http"
  xmlns:exslt="http://exslt.org/common"
  xmlns:exslt-set="http://exslt.org/sets"
  xmlns:exslt-math="http://exslt.org/math"
  xmlns:exslt-functions="http://exslt.org/functions"
  xmlns:exslt-date-time="http://exslt.org/dates-and-times"
  xmlns:dc="&dc;"
  xmlns:fres="&fres;"
  xmlns:bb="&bb;"
  xmlns:bbschema="&bbschema;"
  xmlns:rdf="&rdf;"
  xmlns:f="&f;"
  extension-element-prefixes="f frdf fhttp fcore exslt exslt-set exslt-math exslt-functions exslt-date-time">

  <!--
File:  submit-purchase.xslt

Description:

    Called when a purchase is created or modified

WWW: http://4suite.org        e-mail: support@4suite.org

Copyright 2000-2002 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information

  -->

  <xsl:output method="xml"/>

  <xsl:param name="actionToDo"/>
  <xsl:param name="fres:uri-path"/>
  <xsl:param name="fres:absolute-path"/>

  <xsl:variable name="new-id" select="f:generate-uuid()"/>

  <xsl:template match="/">
    <xsl:choose>
      <xsl:when test="not(fcore:has-session())">
        <fhttp:response-uri uri="/buyerbase/?xslt=home.xslt"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test='$actionToDo = "submit"'>
            <fhttp:response-uri uri="{$fres:uri-path}?xslt=../purchase-summary.xslt"/>
            <xsl:call-template name="new"/>
          </xsl:when>
          <xsl:when test="$actionToDo = 'delete'">
            <fhttp:response-uri uri="{fhttp:local-path(bb:purchase/bb:customer/@id)}?xslt=../purchase-summary.xslt"/>
            <fcore:delete-resource/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>Il n'y a rien</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="new">

    <xsl:variable name='cur' select='fcore:get-session-data("CART")'/>

    <xsl:variable name='toSave' f:node-set='yes'>
      <bb:pending date="{$cur/bb:pending/@date}">
        <xsl:copy-of select='$cur/bb:pending/bb:order[@cust-id = $fres:absolute-path]'/>
      </bb:pending>
    </xsl:variable>

    <xsl:variable name='temp' f:node-set='yes'>
      <bb:pending date="{$cur/bb:pending/@date}">
        <xsl:copy-of select='$cur/bb:pending/bb:order[@cust-id != $fres:absolute-path]'/>
      </bb:pending>
    </xsl:variable>
    <!-- we just want the side-effect of evaluating the test -->
    <xsl:if test='fcore:set-session-data("CART",$temp)'/>

    <xsl:variable name='date' select='$toSave/bb:pending/@date'/>
    <fcore:create-document path='{$new-id}' docdef='../purchase-dd'>
      <bb:purchase id="{$new-id}">
        <bb:date><xsl:value-of select="$date"/></bb:date>
        <bb:customer id="{$fres:absolute-path}"/>
        <xsl:for-each select='$toSave/bb:pending/bb:order'>
          <xsl:variable name="product-info" f:node-set="yes">
            <frdf:versa-query query="distribute(
                                     @'{@prod-id}',
                                     '.-rdfs:label->*',
                                     '.-bbschema:units->*',
                                     '.-bbschema:price->*')"/>
          </xsl:variable>
          <bb:item>
            <bb:product id="{@prod-id}">
              <xsl:value-of select="string($product-info/List/List/List[1]/*[1])"/>
            </bb:product>
            <bb:quantity units="{string($product-info/List/List/List[2]/String[1])}">
              <xsl:value-of select="@qty"/>
            </bb:quantity>
            <bb:unitprice><xsl:value-of select="string($product-info/List/List/List[3]/*[1])"/></bb:unitprice>
          </bb:item>
        </xsl:for-each>
      </bb:purchase>
    </fcore:create-document>
  </xsl:template>

</xsl:stylesheet>
