########################################################################
#
# File Name:            NullWriter.py
#
# Documentation:        http://docs.4suite.org/4XSLT/NullWriter.py.html
#
"""
Implements an empty writer for XSLT processor output
WWW: http://4suite.org/4XSLT        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc., USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""

import cStringIO, codecs
from OutputParameters import OutputParameters

class NullWriter:
    def __init__(self, outputParams=None, stream=None):
        self._outputParams = outputParams or OutputParameters()
        self._stream = stream or cStringIO.StringIO()
        self._savedResult = stream is None
        if self._outputParams.encoding:
            # lookup returns (encoder, decoder, reader, writer)
            writer = codecs.lookup(self._outputParams.encoding)[3]
            self._stream = writer(self._stream)
        return

    def getMediaType(self):
        return self._outputParams.mediaType

    def getResult(self):
        if self._savedResult:
            return self._stream.getvalue()
        return u''

    def startDocument(self):
        return

    def endDocument(self):
        return
    
    def text(self, text, escapeOutput=1, asis=0):
        return
    
    def attribute(self, name, value, namespace=None):
        return

    def processingInstruction(self, target, data):
        return

    def comment(self, body):
        return

    def startElement(self, name, namespace=None, extraNss=None):
        return

    def endElement(self, name):
        return
