########################################################################
#
# File Name:            PlainTextWriter.py
#
# Documentation:        http://docs.4suite.org/4XSLT/PlainTextWriter.py.html
#
"""
Implements a text output writer for XSLT processor output
WWW: http://4suite.org/4XSLT        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc., USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""

from Ft.Xml import EMPTY_NAMESPACE
from Ft.Xml.Xslt import NullWriter

class PlainTextWriter(NullWriter.NullWriter):
    def __init__(self, outputParams, stream=None):
        outputParams.setDefault('mediaType', 'text/plain')
        # the default is actually system-dependent; we'll use UTF-8
        outputParams.setDefault('encoding', 'utf-8')
        NullWriter.NullWriter.__init__(self, outputParams, stream)
        return
        
    # the NullWriter already defines the rest of the handlers as no-ops

    def text(self, text, escapeOutput=1, asis=0):
        self._stream.write(text)
        return
